(function(window){
    var u = {};

u.init = function()
{
    /* Get a reference to the element that will contain the leaves */
    var container = $("body");
    for(var index in document.styleSheets[0].cssRules){
    var rule = document.styleSheets[0].cssRules[index];
    
    if(rule.name&&rule.name == "drop"){
        rule.findRule("0%").style.transform = "translate(0px, "+(document.body.scrollHeight-10)+"px)";
        rule.findRule("100%").style.transform = "translate(0px,150px)";
        // alert(rule.findRule("0%").style.transform);
        }

    }

}


/*
    Receives the lowest and highest values of a range and
    returns a random integer that falls within that range.
*/
function randomInteger(low, high)
{
    return low + Math.floor(Math.random() * (high - low));
}


/*
   Receives the lowest and highest values of a range and
   returns a random float that falls within that range.
*/
function randomFloat(low, high)
{
    return low + Math.random() * (high - low);
}


/*
    Receives a number and returns its CSS pixel value.
*/
function pixelValue(value)
{
    return value + 'px';
}


/*
    Returns a duration value for the falling animation.
*/

function durationValue(value)
{
    return value + 's';
}


/*
    Uses an img element to create each leaf. "Leaves.css" implements two spin 
    animations for the leaves: clockwiseSpin and counterclockwiseSpinAndFlip. This
    function determines which of these spin animations should be applied to each leaf.
    
*/
u.createBean = function()
{
    /* Start by creating a wrapper div, and an empty img element */
    var leafDiv = document.createElement('div');
    var image = document.createElement('img');
    leafDiv.className="coffeebean";
    /* Randomly choose a leaf image and assign it to the newly created element */
    image.src = '../../image/video/bean' + randomInteger(1, 6) + '.png';
    
    leafDiv.style.top = "-100px";

    /* Position the leaf at a random location along the screen */
    leafDiv.style.right = "15px";
    
    /* Randomly choose a spin animation */
    // var spinAnimationName = (Math.random() < 0.5) ? 'clockwiseSpin' : 'counterclockwiseSpinAndFlip';
    var spinAnimationName = 'clockwiseSpin';
    /* Set the -webkit-animation-name property with these values */
    leafDiv.style.webkitAnimationName = 'fade, drop';
    image.style.webkitAnimationName = spinAnimationName;
    
    /* Figure out a random duration for the fade and drop animations */
    var fadeAndDropDuration = durationValue(randomFloat(4, 7));
    
    /* Figure out another random duration for the spin animation */
    var spinDuration = durationValue(randomFloat(5, 8));
    /* Set the -webkit-animation-duration property with these values */
    leafDiv.style.webkitAnimationDuration = fadeAndDropDuration + ', ' + fadeAndDropDuration;

    // var leafDelay = durationValue(randomFloat(0, 5));
    // leafDiv.style.webkitAnimationDelay = leafDelay + ', ' + leafDelay;

    image.style.webkitAnimationDuration = spinDuration;

    // add the <img> to the <div>
    leafDiv.appendChild(image);

    /* Return this img element so it can be added to the document */
    return leafDiv;
}

  

    window.$coffeebean = u;

})(window);